﻿using HarmonyLib;
using System.Collections;
using UnityEngine;

public class BetterBows : Mod
{
    AssetBundle bundle;
    ItemObjectEnabler DefaultBow_throwablePrefabs;
    public System.Collections.Generic.Dictionary<Item_Base, float> DamageMultiplierTable = new System.Collections.Generic.Dictionary<Item_Base, float>();

    public IEnumerator Start()
    {
        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("betterbows.assets"));
        yield return request;
        bundle = request.assetBundle;
        DefaultBow_throwablePrefabs = (ItemObjectEnabler)AccessTools.Field(typeof(ThrowableComponent_Bow), "throwablePrefabs").GetValue(ComponentManager<Semih_Network>.Value.playerPrefab.GetComponentInChildren<ThrowableComponent_Bow>());
        //RegisterArrow(bundle.LoadAsset<Item_Base>("arrow_diamond"), bundle.LoadAsset<GameObject>("Arrow_Diamond"));
        RegisterBow(bundle.LoadAsset<Item_Base>("MetalBow_Item"), bundle.LoadAsset<GameObject>("MetalBow_Prefab"));
        RegisterBow(bundle.LoadAsset<Item_Base>("ProfessionalBow_Item"), bundle.LoadAsset<GameObject>("ProfessionalBow_Prefab"));
        RegisterBow(bundle.LoadAsset<Item_Base>("TaDeNightBow_Item"), bundle.LoadAsset<GameObject>("TaDeNightBow_Prefab"));
    }

    /*GameObject diamondArrow_DefaultBowRef;
    public void Update()
    {
        if (Semih_Network.InLobbyScene || RAPI.GetLocalPlayer() == null || diamondArrow_DefaultBowRef != null || RAPI.GetLocalPlayer().Inventory == null) { return; }
        ItemInstance currentitem = RAPI.GetLocalPlayer().Inventory.GetSelectedHotbarItem();
        if (currentitem != null && currentitem.baseItem.UniqueIndex == 185)
        {
            Transform parent = RAPI.GetLocalPlayer().rightHandParent.transform.Find("Bow").Find("Bow").Find("Armature_Bow").Find("Root").Find("StringMiddle");
            if (!parent.transform.Find("ArrowDiamond_LocalPrefab"))
            {
                diamondArrow_DefaultBowRef = Instantiate(bundle.LoadAsset<GameObject>("ArrowDiamond_LocalPrefab"), parent.transform.Find("Bow_ArrowModel_Metal").position, parent.transform.Find("Bow_ArrowModel_Metal").rotation, parent);
                diamondArrow_DefaultBowRef.name = "ArrowDiamond_LocalPrefab";
                diamondArrow_DefaultBowRef.SetActive(true);

                ItemObjectEnabler basebowmodel = (ItemObjectEnabler)AccessTools.Field(typeof(ThrowableComponent_Bow), "throwableModelEnabler").GetValue(ComponentManager<Semih_Network>.Value.playerPrefab.GetComponentInChildren<ThrowableComponent_Bow>());
                ItemModelConnection[] i = Traverse.Create(basebowmodel).Field("itemConnections").GetValue() as ItemModelConnection[];
                List<ItemModelConnection> newshit = i.ToList();
                ItemModelConnection it = new ItemModelConnection();
                it.item = ItemManager.GetItemByIndex(18003);
                it.model = diamondArrow_DefaultBowRef;
                newshit.Add(it);
                Traverse.Create(basebowmodel).Field("itemConnections").SetValue(newshit.ToArray());
            }
        }
    }

    public void RegisterArrow(Item_Base item, GameObject prefab)
    {
        RAPI.RegisterItem(item);
        ItemModelConnection[] i = Traverse.Create(DefaultBow_throwablePrefabs).Field("itemConnections").GetValue() as ItemModelConnection[];
        List<ItemModelConnection> newshit = i.ToList();
        ItemModelConnection it = new ItemModelConnection();
        it.item = item;
        it.model = prefab;
        newshit.Add(it);
        Traverse.Create(DefaultBow_throwablePrefabs).Field("itemConnections").SetValue(newshit.ToArray());

        // Enabling new arrows on base bow
        AccessTools.Field(typeof(ThrowableComponent_Bow), "throwablePrefabs").SetValue(ComponentManager<Semih_Network>.Value.playerPrefab.GetComponentInChildren<ThrowableComponent_Bow>(), DefaultBow_throwablePrefabs);
    }*/

    public void RegisterBow(Item_Base item, GameObject prefab, float damageMultiplier = 1)
    {
        RAPI.RegisterItem(item);
        AccessTools.Field(typeof(ThrowableComponent_Bow), "throwablePrefabs").SetValue(prefab.GetComponentInChildren<ThrowableComponent_Bow>(), DefaultBow_throwablePrefabs);
        RAPI.SetItemObject(item, prefab);
        DamageMultiplierTable.Add(item, damageMultiplier);
        //RConsole.Log("[BetterBows] Successfully registered bow : " + item.settings_Inventory.DisplayName);
    }
}